#ifndef Func_H
#define Func_H 1

#include "base/Operator.h"
#include "base/DataInCoreFloat.h"
#include "base/inCoreFloat.h"
#include "Clean.h"
#include "Engine.h"
#include <omp.h>
typedef long long llong;
#define C1 0.125
#define C2 0.25
/*
	Created by Yinbin Ma  
	4th order Laplacian in 2 d.
	Use carefully and have fun.
	
	First created: 2015-01-01
	Last Modified: 2015-02-28
*/	

namespace SEP {
/*
class FuncGrad: public Operator{
  public:
    FuncGrad(Space *mod, Space *data){
      setDomain(mod);
      setRange(data);
    }
    void Evaluate(Vector *m, double *f, Vector *grad){
      float *__restrict__ m_val = ((dataInCoreFloat*)m->getDataContainer())->getFloatPtr();
      float *__restrict__ g_val = ((dataInCoreFloat*)grad->getDataContainer())->getFloatPtr();
      *f = 0.;
      double x, y;
      x = m_val[0]; y = m_val[1];
      //std::cout << " lala " << x<< std::endl;
      //std::cout << " lala " << y<< std::endl;
      *f = 4*x*x - 4*x*y + 2*y*y;
      g_val[0] = 8*x - 4*y; //std::cout << " haha "<< g_val[0] << std::endl;
      g_val[1] = 4*y - 4*x; //std::cout << " haha "<< g_val[1] << std::endl;
    
    }
    virtual bool Forward(bool add, Vector *model, Vector *data){}
    virtual bool Adjoint(bool add, Vector *model, Vector *data){}
    ~FuncGrad(){}
    private:

};
*/

double ObjFuc(float *dataRes, int len){
  double obj=0.;
  for(int i=0; i < len; i++){
    obj += dataRes[i]*dataRes[i];
    //if(i%10000==0)
    //std::cout <<" i = " << i <<", obj =" << obj<<std::endl;
  }
  return obj;
}

class FuncGrad: public Operator{
  public:
    FuncGrad(Space *mod, Space *data){
      setDomain(mod);
      setRange(data);
    }
    void SetData(float *_dataRes, float *_dataTrue, double *_dataResD){
      dataRes = _dataRes;
      dataTrue = _dataTrue;
      dataResD=_dataResD;
    }
    void SetOp(Engine *_Run,Vector *_drho, Vector *_rho0, int _nsize, Vector *_Mask){
      Run = _Run;
      drho=_drho;
      rho0 = _rho0;
      nsize=_nsize;
      Mask = _Mask;
      }
    void Evaluate(Vector *m, double *f, Vector *grad){
      Run->SetModel(m,rho0);
      Run->CreateData();
      Run->GetData(dataRes);
      for(int j=0; j < nsize; j++) { 
        dataRes[j] = dataRes[j]-dataTrue[j];  
      }
      *f = ObjFuc(dataRes,nsize);
      //std::cout << "    nsize = "<<nsize <<"   f = " << *f << std::endl;
      Run->PutData(dataRes);
      grad->zeroElement();
      Run->GradientFunc(grad,drho,m,rho0);
      //std::cout << "   wtf: " << m->innerProd(*m)<<", "<<grad->innerProd(*grad) << std::endl;
      grad->scale(0.001);
      float *__restrict__ mval = ((dataInCoreFloat*)Mask->getDataContainer())->getFloatPtr();
      float *__restrict__ gval = ((dataInCoreFloat*)grad->getDataContainer())->getFloatPtr();  
      for(int j=0; j < 501*201; j++) { 
        gval[j] = gval[j]*mval[j];  
      }
      
    }
    virtual bool Forward(bool add, Vector *model, Vector *data){}
    virtual bool Adjoint(bool add, Vector *model, Vector *data){}
    ~FuncGrad(){}
    private:
      Engine *Run;
      Vector *drho, *rho0, *Mask;
      float *dataRes, *dataTrue;
      double *dataResD;
      int nsize;

};

}
#endif