#include <iostream>
#include <cstdlib>
#include <stdbool.h>
#include <vector>
#include <cmath>
#include<string>
#include "seplib.h"
#include <omp.h>
#include "base/utilities.h"

#include "base/Vector.h"
#include "base/inCoreFloat.h"
#include "base/DataInCoreFloat.h"
#include "base/Operator.h"
#include "base/MultiOperator.h"

#include "CreateModel.h"
#include "Source.h"
#include "SensorPad.h"
#include "Grad.h"
#include "Prop.h"

using namespace std;
using namespace SEP;

/*
Beta version for Multiparameter FWI

Generated by Yinbin: 2015-07-06

Assume: 
	1) source term
	2) initial condition with gradient = 0
	3) K[GPa], t[ms], rho[g/cm^3]
*/



int main(int argc, char *argv[]) {
  cout << "========================================"<<endl;
  cout << "                                        "<<endl;
  cout << "========================================"<<endl;
  cout << "         Full Waveform inversion.        "<<endl;
  initpar(argc,argv);       // Initialize the sep library
  omp_set_num_threads(1);   // Initialize the parallel environment
  
  int nx=501;
  int nz=201;
  float *MV = new float[nx*nz];
  float *TV = new float[nx*nz];
  
  sreed("qianS",MV,sizeof(float)*nx*(nz-1));   
  sreed("qianT",TV,sizeof(float)*nx*(nz-1)); 
  float valueM,valueT;
  for(int iz=0; iz<nz;iz++){
    for(int ix=0; ix < nx; ix++){
      int pos = iz*nx+ix;
      if(iz < 70){
        MV[pos] = 2400.;
        TV[pos] = 2400.;
      }
    }
  }
  for(int ix=0; ix < nx; ix++){
    MV[(nz-1)*nx+ix] = MV[(nz-2)*nx+ix];
    TV[(nz-1)*nx+ix] = TV[(nz-2)*nx+ix];   
  }
  float rho = 2.;
  for(int i=0; i < nx*nz;i++){
    double temp = (MV[i]/1000.)*(MV[i]/1000.);
    MV[i] = temp*rho;
    temp = (TV[i]/1000.)*(TV[i]/1000.);
    TV[i] = temp*rho;
  }

  
  srite("houS",MV,sizeof(float)*nx*nz);   
  srite("houT",TV,sizeof(float)*nx*nz); 

}