#include <iostream>
#include <cstdlib>
#include <stdbool.h>
#include <vector>
#include <cmath>
#include<string>
#include "seplib.h"
#include <omp.h>
#include "base/utilities.h"

#include "base/Vector.h"
#include "base/inCoreFloat.h"
#include "base/DataInCoreFloat.h"
#include "base/Operator.h"
#include "base/MultiOperator.h"

#include "CreateModel.h"
#include "Source.h"
#include "SensorPad.h"
#include "Grad.h"
#include "Prop.h"

using namespace std;
using namespace SEP;

/*
Beta version for Multiparameter FWI

Generated by Yinbin: 2015-07-06

Assume: 
	1) source term
	2) initial condition with gradient = 0
	3) K[GPa], t[ms], rho[g/cm^3]
*/



int main(int argc, char *argv[]) {
  cout << "========================================"<<endl;
  cout << "                                        "<<endl;
  cout << "========================================"<<endl;
  cout << "         Full Waveform inversion.        "<<endl;
  initpar(argc,argv);       // Initialize the sep library
  omp_set_num_threads(1);   // Initialize the parallel environment
  
  
  float *V = new float[1000*500];
  sreed("raw",V,sizeof(float)*1000*500);   


  for(int iz=0; iz<500;iz++){
    for(int ix=0; ix < 1000; ix++){
    int i = iz*1000+ix;
    if(V[i] > 4410 && iz<450){
       V[i] = 2650. +(iz-200)*2.;
    }
    else{
      V[i] = V[i]*0.7;
    }
    }
  }
  srite("new",V,sizeof(float)*1000*500);

}