#include <iostream>
#include <cstdlib>
#include <stdbool.h>
#include <vector>
#include <cmath>
#include<string>
#include "seplib.h"
#include <omp.h>
#include "base/utilities.h"
#include "mkl_rci.h"


#include "base/Vector.h"
#include "base/inCoreFloat.h"
#include "base/DataInCoreFloat.h"
#include "base/Operator.h"
#include "base/MultiOperator.h"

#include "CreateModel.h"
#include "Source.h"
#include "SensorPad.h"
#include "Grad.h"
#include "Prop.h"
#include "NCG.h"
using namespace std;
using namespace SEP;

/*
Beta version for Multiparameter FWI

Generated by Yinbin: 2015-07-06

Assume: 
	1) source term
	2) initial condition with gradient = 0
	3) K[GPa], t[ms], rho[g/cm^3]
*/


extern "C" void dcg_init(MKL_INT *n, double *x,double *b, MKL_INT *rci_request, MKL_INT *ipar, double *dpar, double *tmp);

int main(int argc, char *argv[]) {
  cout << "========================================"<<endl;
  cout << "                                        "<<endl;
  cout << "========================================"<<endl;
  cout << "         Full Waveform inversion.        "<<endl;
  initpar(argc,argv);       // Initialize the sep library
  omp_set_num_threads(1);   // Initialize the parallel environment
  int nt = 2;
  // Set up space 
  inCoreFloat1D mspace(nt);               // space for shot  
  FuncGrad *func = new FuncGrad(&mspace,&mspace);
  Vector *m = new Vector(&mspace);
  Vector *m0 = new Vector(&mspace);
  Vector *grad = new Vector(&mspace);
  Vector *grad0 = new Vector(&mspace);
  Vector *d = new Vector(&mspace);
  double f0;
  float *__restrict__ m_val = ((dataInCoreFloat*)m0->getDataContainer())->getFloatPtr();
  float *__restrict__ g_val = ((dataInCoreFloat*)grad->getDataContainer())->getFloatPtr();   
  m_val[0] = 2.;
  m_val[1] = 3.;
  func->Evaluate(m0,&f0,grad0);
  std::cout << "Function value = " << f0 << std::endl;
  std:;cout << "grad norm = " << grad->innerProd(*grad) << std::endl; 
  double alpha,f; 
  int nsteps;
  NCG *ncg = new NCG(&mspace);
  ncg->run(m, m0, func);
  m0->linearCombo(0.,*m,1.);
  std::cout << "haha" << m_val[0] << std::endl;
  std::cout << "haha" << m_val[1] << std::endl;
  /*
  LineSearch * LS = new LineSearch(&mspace);
  for(int i=0; i <5;i++){
  func->Evaluate(m0,&f0,grad0);
  d->linearCombo(0.,grad0,-1.); grad->linearCombo(0.,grad0,1.);
  cout << "("<< g_val[0] <<", "<<g_val[1]<< ")"<<endl;
  LS->run(&alpha,m,&f,grad, &nsteps, m0, f0, grad0,d,func);
  cout << "Line search finished in:" << nsteps << " steps, alpha = "<< alpha << ",value = " << f<< endl;
  m0->linearCombo(0.,*m,1.);
  }
  */
    return 0;
}